<!-- Based on https://observablehq.com/@d3/color-legend, Copyright 2021, Observable Inc. Released under the ISC license. -->
<script>
	import * as d3 from 'd3';
    export let color;
	export let title = "";
	export let tickSize = 4;
    export let xScale;
    export let subplotLayout;
    export let barWidth = 200;
    export let barHeight = 10;
    export let leftOffset = 30;
    export let bottomOffset = 30;
	export let ticks = barWidth / 64;
	export let tickFormat;
	export let tickValues;

    $: bottom = subplotLayout.y + subplotLayout.h - bottomOffset;
    $: top = bottom - barHeight;
    $: tickBottom = bottom + tickSize;
    $: left = xScale.range()[0] + leftOffset;
    $: right = left + barWidth;

//     $: right = left + width;
//     let bottom = top + height;
//     $: tickBottom = top + height + tickSize;
//
	let type;
    $: x = Object.assign(color.copy()
            .interpolator(d3.interpolateRound(left, right)),
                {range() { return [left, right]; }});
    let n;

	const ramp = function(color, n = 256) {
		const canvas = document.createElement("canvas");
		canvas.width = n;
		canvas.height = 1;
		const context = canvas.getContext("2d");
		for (let i = 0; i < n; ++i) {
			context.fillStyle = color(i / (n - 1));
			context.fillRect(i, 0, 1, 1);
		}
		return canvas;
	}

    // Continuous
    if (color.interpolate) {
        type = "continuous";
        n = Math.min(color.domain().length, color.range().length);
        x = color.copy().rangeRound(d3.quantize(d3.interpolate(left, left + barWidth), n));
    }

    // Sequential
    else if (color.interpolator) {
        type = "sequential";
        $: x = Object.assign(color.copy()
	        .interpolator(d3.interpolateRound(left, right)),
	        {range() { return [left, right]; }});
//
//         // scaleSequentialQuantile doesn’t implement ticks or tickFormat.
//         if (!x.ticks) {
//               if (tickValues === undefined) {
// 	            n = Math.round(ticks + 1);
// 	            tickValues = d3.range(n).map(i => d3.quantile(color.domain(), i / (n - 1)));
//             }
//             if (typeof tickFormat !== "function") {
// 	           tickFormat = d3.format(tickFormat === undefined ? ",f" : tickFormat);
//             }
//         }
    }

    // Threshold
    else if (color.invertExtent) {
        type = "threshold";
//         const thresholds
// 	        = color.thresholds ? color.thresholds() // scaleQuantize
// 	        : color.quantiles ? color.quantiles() // scaleQuantile
// 	        : color.domain(); // scaleThreshold
//
//         const thresholdFormat
// 	        = tickFormat === undefined ? d => d
// 	        : typeof tickFormat === "string" ? d3.format(tickFormat)
// 	        : tickFormat;
//
//         x = d3.scaleLinear()
// 	        .domain([-1, color.range().length - 1])
// 	        .rangeRound([marginLeft, barWidth - marginRight]);

        // svg.append("g")
        //   .selectAll("rect")
        //   .data(color.range())
        //   .join("rect")
	    //     .attr("x", (d, i) => x(i - 1))
	    //     .attr("y", marginTop)
	    //     .attr("width", (d, i) => x(i) - x(i - 1))
	    //     .attr("height", height - marginTop - marginBottom)
	    //     .attr("fill", d => d);

        tickValues = d3.range(thresholds.length);
        tickFormat = i => thresholdFormat(thresholds[i], i);
    }

    // Ordinal
    else {
        type = "ordinal";
        // x = d3.scaleBand()
        //     .domain(color.domain())
        //     .rangeRound([marginLeft, barWidth - marginRight]);

        // svg.append("g")
        //   .selectAll("rect")
        //   .data(color.domain())
        //   .join("rect")
        //     .attr("x", x)
        //     .attr("y", marginTop)
        //     .attr("width", Math.max(0, x.bandwidth() - 1))
        //     .attr("height", height - marginTop - marginBottom)
        //     .attr("fill", color);

        // tickAdjust = () => {};
    }

</script>
<g class="colorScaleLegend">
    <rect x="{left-20}"
          y="{top-20}"
          width="{barWidth+40}"
          height="{barHeight+40}"
          fill="white"
          fill-opacity="0.95"/>

    {#if type == "continuous"}
        <image x="{left}"
               y="{top}"
               width="{barWidth}"
               height="{barHeight}"
               preserveAspectRatio="none"
               xlink:href={ramp(color.copy().domain(d3.quantize(d3.interpolate(0, 1), n))).toDataURL()}/>
    {:else if type == "sequential"}
        <image x="{left}"
               y="{top}"
               width="{barWidth}"
               height="{barHeight}"
               preserveAspectRatio="none"
               xlink:href={ramp(color.interpolator()).toDataURL()}/>
    {/if}

    {#each x.ticks(ticks) as tick}
        <line
            x1={x(tick)}
            x2={x(tick)}
            y1="{top}"
            y2="{tickBottom}"
            stroke="black"
            stroke-width="1px"/>
        <text
            x="{x(tick)}"
            y="{tickBottom+12}"
            font-size="11px"
            text-anchor="middle"
            >{tick}</text>
    {/each}
    <text x="{left}"
          y="{top-4}"
          font-size="11px"
          alignment-baseline="text-bottom"
          text-anchor="start"
          font-weight="bold">{title}</text>

<!-- Common annotation -->
    <!-- svg.append("g")
  .attr("transform", `translate(0,${height - marginBottom})`)
  .call(d3.axisBottom(x)
    .ticks(ticks, typeof tickFormat === "string" ? tickFormat : undefined)
    .tickFormat(typeof tickFormat === "function" ? tickFormat : undefined)
    .tickSize(tickSize)
    .tickValues(tickValues))
  .call(tickAdjust)
  .call(g => g.select(".domain").remove())
  .call(g => g.append("text")
    .attr("x", marginLeft)
    .attr("y", marginTop + marginBottom - height - 6)
    .attr("fill", "currentColor")
    .attr("text-anchor", "start")
    .attr("font-weight", "bold")
    .attr("class", "title")
    .text(title)); -->
</g>